var child_process = require("child_process"), os = require("os");

var DEFAULT_CONTROL_PANEL_PORT = 1337, DEFAULT_SERVICE_PORT = 1338;

function isPortFree(port, callback) {
    var platform = os.platform();
    if (platform.match(/^win/)) {
        child_process.exec("netstat -an", function(error, stdout) {
            callback(stdout.indexOf(":" + port) === -1);
        });
    } else {
        if (platform === "darwin") {
            child_process.exec("sudo lsof -i -P | grep :" + port, function(error, stdout) {
                callback(!stdout.length);
            });
        } else {
            child_process.exec("sudo netstat -plnt | grep :" + port, function(error, stdout) {
                callback(!stdout.length);
            });
        }
    }
}

function getFreePort(defaultPort, callback, except) {
    if (defaultPort === except) {
        defaultPort++;
    }
    isPortFree(defaultPort, function(free) {
        if (free) {
            callback(defaultPort);
        } else {
            getFreePort(defaultPort + 1, function(port) {
                callback(port);
            }, except);
        }
    });
}

exports.getFreePorts = function(callback) {
    var result = {};
    getFreePort(DEFAULT_CONTROL_PANEL_PORT, function(controlPanelPort) {
        result.controlPanelPort = controlPanelPort;
        getFreePort(DEFAULT_SERVICE_PORT, function(servicePort) {
            result.servicePort = servicePort;
            callback(result);
        }, controlPanelPort);
    });
};