TestCafeClient = typeof TestCafeClient === "undefined" ? {} : TestCafeClient;

TestCafeClient.pageProc = TestCafeClient.pageProc || {};

(function() {
    var TCC = TestCafeClient, isNode = typeof module !== "undefined" && module.exports, consts = isNode ? require("./const") : TCC, urlUtil = isNode ? require("./url_util") : TCC.urlUtil, root = isNode ? exports : TCC.pageProc;
    var CSS_URL_PROPERTY_VALUE_PATTERN = /(url\s*\(\s*)(?:(')([^\s']+)(')|(")([^\s"]+)(")|([^\s\)]+))(\s*\))|(@import\s+)(?:(')([^\s']+)(')|(")([^\s"]+)("))/g, EVENTS = [ "onblur", "onchange", "onclick", "oncontextmenu", "oncopy", "oncut", "ondblclick", "onerror", "onfocus", "onfocusin", "onfocusout", "onhashchange", "onkeydown", "onkeypress", "onkeyup", "onload", "onmousedown", "onmouseenter", "onmouseleave", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onmousewheel", "onpaste", "onreset", "onresize", "onscroll", "onselect", "onsubmit", "ontextinput", "onunload", "onwheel" ], EVENT_HANDLERS_SELECTOR = "[" + EVENTS.join("],[") + "]", BOM_REGEX = new RegExp("^(\\xEF\\xBB\\xBF|" + "\\xFE\\xFF|" + "\\xFF\\xFE|" + "\\x00\\x00\\xFE\\xFF|" + "\\xFF\\xFE\\x00\\x00|" + "\\x2B\\x2F\\x76\\x38|" + "\\x2B\\x2F\\x76\\x39|" + "\\x2B\\x2F\\x76\\x2B|" + "\\x2B\\x2F\\x76\\x2F|" + "\\xF7\\x64\\x4C|" + "\\xDD\\x73\\x66\\x73|" + "\\x0E\\xFE\\xFF|" + "\\xFB\\xEE\\x28|" + "\\x84\\x31\\x95\\x33)"), URL_ATTR_REG_EX_FORMAT = "\\s({1}|{2})(?:\\s*=\\s*(\"([^\"]*)\"|'([^']*)')|(?=[\\s>/]))", TAG_NAME_REG_EX_FORMAT = "<({0})[^<>]*", TAG_REG_EX_FORMAT = TAG_NAME_REG_EX_FORMAT + URL_ATTR_REG_EX_FORMAT + "[^<>]*>";
    var wrapRegEx = new RegExp("(" + consts.PROPERTIES_FOR_WRAPPING.join("|") + ")(\\W|$)", "g"), wrappersBasis = [];
    for (var i = 0; i < consts.PROPERTIES_FOR_WRAPPING.length; i++) {
        wrappersBasis.push(consts.PROPERTIES_FOR_WRAPPING[i].substr(0, consts.PROPERTIES_FOR_WRAPPING[i].length - 1));
    }
    var unwrapRegEx = new RegExp("(" + wrappersBasis.join("|") + ")" + consts.DOM_SANDBOX_WRAPPER_SYMBOL + "(\\W|$)", "g"), wrapReplacements = {};
    for (var i = 0; i < wrappersBasis.length; i++) {
        wrapReplacements[wrappersBasis[i]] = consts.PROPERTIES_FOR_WRAPPING[i];
    }
    var getBOM = function(text) {
        var match = text.match(BOM_REGEX);
        return match ? match[0] : null;
    };
    var getAttr = function($el, attr) {
        return isNode ? $el[0].attribs[attr] : TCC.sandboxes.dom.nativeMethods.getAttribute.call($el[0], attr);
    };
    var getTagName = function($el) {
        return isNode ? $el[0].name : $el[0].tagName;
    };
    var setAttr = function($el, attr, value) {
        return isNode ? $el[0].attribs[attr] = value : TCC.sandboxes.dom.nativeMethods.setAttribute.call($el[0], attr, value);
    };
    var removeAttr = function($el, attr) {
        return isNode ? $el.removeAttr(attr) : TCC.sandboxes.dom.nativeMethods.removeAttribute.call($el[0], attr);
    };
    var syncWrapProps = function($el, urlAttr) {
        var wrapUrlAttr = root.getWrapper(urlAttr), url = getAttr($el, urlAttr), wrapUrl = getAttr($el, wrapUrlAttr);
        if (!url && wrapUrl) {
            setAttr($el, urlAttr, wrapUrl);
            removeAttr($el, wrapUrlAttr);
        }
    };
    var parseUrlAttrs = function(tagStr, urlAttr) {
        var urlAttrWrap = root.getWrapper(urlAttr), urlAttrRegExStr = URL_ATTR_REG_EX_FORMAT.replace("{1}", urlAttr).replace("{2}", urlAttrWrap), urlAttrRegEx = new RegExp(urlAttrRegExStr, "gi"), match = urlAttrRegEx.exec(tagStr), result = {};
        while (match) {
            var parsedUrlAttr = {
                str: match[0],
                name: match[1],
                quote: match[0].substr(-1, 1),
                value: match[3] || match[4] || "",
                empty: typeof match[2] === "undefined"
            };
            result[match[1] === urlAttr ? urlAttr : urlAttrWrap] = parsedUrlAttr;
            match = urlAttrRegEx.exec(tagStr);
        }
        return result;
    };
    var attrNameWrappingRequired = function($el, attr) {
        var tagName = getTagName($el).toLowerCase();
        return (attr !== "action" || tagName !== "form") && (attr !== "href" || tagName !== "a" && tagName !== "area" && tagName !== "link" && tagName !== "base") && (attr !== "hreflang" || tagName !== "a" && tagName !== "link") && (attr !== "nohref" || tagName !== "area") && (attr !== "src" || tagName !== "script" && tagName !== "input" && tagName !== "frame" && tagName !== "iframe" && tagName !== "img" && tagName !== "embed");
    };
    var enumAttrs = function($el, action) {
        if (isNode) {
            Object.keys($el[0].attribs).forEach(function(attr) {
                if (attr.indexOf(consts.DOM_SANDBOX_STORED_ATTR_KEY_PREFIX) === -1) {
                    action(attr);
                }
            });
        } else {
            var attributes = $el[0].attributes || [];
            for (var i = 0; i < attributes.length; i++) {
                var attr = attributes[i].nodeName;
                if (attr.indexOf(consts.DOM_SANDBOX_STORED_ATTR_KEY_PREFIX) === -1) {
                    action(attr);
                }
            }
        }
    };
    var processTargetBlank = function($el) {
        var attrValue = getAttr($el, "target");
        if (attrValue && attrValue.replace(/\s/g, "") === "_blank") {
            setAttr($el, "target", "_self");
        }
    }, processStylesheet = function($el, urlReplacer) {
        if (isNode) {
            var contentChild = $el[0].children.length ? $el[0].children[0] : null;
            if (contentChild && contentChild.data && urlReplacer) {
                contentChild.data = root.processStylesheet(contentChild.data, urlReplacer);
            }
        }
    }, processStyleAttr = function($el, urlReplacer) {
        var style = getAttr($el, "style");
        if (style) {
            setAttr($el, "style", root.processStylesheet(style, urlReplacer));
        }
    }, processScript = function($script) {
        if (isNode) {
            var contentChild = $script[0].children.length ? $script[0].children[0] : null;
            if (!contentChild || !contentChild.data) {
                return;
            }
            var scriptType = getAttr($script, "type"), executableScriptTypesRegEx = /(application\/((x-)?ecma|(x-)?java)script)|(text\/)(javascript(1\.{0-5})?|((x-)?ecma|x-java|js|live)script)/, isExecutableScript = !scriptType || executableScriptTypesRegEx.test(scriptType);
            if (isExecutableScript) {
                contentChild.data = root.processScript(contentChild.data);
            }
        }
    }, processEvtHandlers = function($el) {
        if (isNode) {
            for (var i = 0; i < EVENTS.length; i++) {
                var attr = getAttr($el, EVENTS[i]);
                if (attr) {
                    setAttr($el, EVENTS[i], root.processScript(attr, true));
                }
            }
        }
    }, processUrlAttrs = function($el, urlReplacer, pattern) {
        if (urlReplacer && pattern.urlAttr) {
            syncWrapProps($el, pattern.urlAttr);
            var wrapUrlAttr = root.getWrapper(pattern.urlAttr), resourceUrl = getAttr($el, pattern.urlAttr), processedOnServer = !!getAttr($el, wrapUrlAttr);
            if ((resourceUrl || resourceUrl === "") && !processedOnServer) {
                if (urlUtil.isSupportedProtocol(resourceUrl)) {
                    setAttr($el, pattern.urlAttr, resourceUrl ? urlReplacer(resourceUrl, pattern.isIFrame) : "");
                } else {
                    setAttr($el, pattern.urlAttr, resourceUrl || "");
                }
                resourceUrl = root.wrapProps(resourceUrl);
                setAttr($el, wrapUrlAttr, resourceUrl);
            }
        }
    }, processIframeUrl = function($el, urlReplacer, pattern) {
        if (urlReplacer) {
            syncWrapProps($el, pattern.urlAttr);
            var iframeUrl = getAttr($el, pattern.urlAttr);
            if (iframeUrl || iframeUrl === "") {
                var originUrlObj = urlUtil.parseProxyUrl(urlReplacer("/")).originResourceInfo, originUrl = urlUtil.formatUrl(originUrlObj);
                if (urlUtil.sameOriginCheck(originUrl, iframeUrl)) {
                    processUrlAttrs($el, urlReplacer, pattern);
                }
            }
        }
    }, processIframe = function($el) {
        if (!isNode && !root.isCrossDomainIframe($el[0]) && TCC.iframeWatch) {
            TCC.iframeWatch.overrideIframe($el);
        }
    }, processAutoComplete = function($el) {
        setAttr($el, "autocomplete", "off");
    }, processMeta = function($el, urlReplacer, pattern) {
        if (getAttr($el, "http-equiv").toLowerCase() === "refresh") {
            var attr = getAttr($el, pattern.urlAttr);
            attr = attr.replace(/(url=)(.*)$/i, function() {
                return arguments[1] + urlReplacer(arguments[2]);
            });
            setAttr($el, pattern.urlAttr, attr);
        }
    }, processAttrValue = function($el) {
        enumAttrs($el, function(attr) {
            if (attr === "id" || attr === "class" || attr.indexOf("data-") === 0) {
                setAttr($el, attr, root.wrapProps(getAttr($el, attr)));
            }
        });
    }, processCustomAttr = function($el) {
        enumAttrs($el, function(attr) {
            if (attrNameWrappingRequired($el, attr)) {
                var replacedAttr = root.wrapProps(attr);
                if (replacedAttr !== attr) {
                    setAttr($el, replacedAttr, getAttr($el, attr));
                    removeAttr($el, attr);
                }
            }
        });
    };
    var ELEMENT_PROCESSOR_PATTERNS = [ {
        selector: "a, link, image, area, base",
        urlAttr: "href",
        elementProcessors: [ processTargetBlank, processUrlAttrs ]
    }, {
        selector: "img, embed, script",
        urlAttr: "src",
        elementProcessors: [ processTargetBlank, processUrlAttrs ]
    }, {
        selector: "form",
        urlAttr: "action",
        elementProcessors: [ processTargetBlank, processUrlAttrs ]
    }, {
        selector: "iframe",
        urlAttr: "src",
        isIFrame: true,
        elementProcessors: [ processTargetBlank, processIframeUrl, processIframe ]
    }, {
        selector: "meta[http-equiv]",
        urlAttr: "content",
        elementProcessors: [ processMeta ]
    }, {
        selector: "html",
        urlAttr: "manifest",
        elementProcessors: [ processUrlAttrs ]
    }, {
        selector: "*",
        elementProcessors: [ processAttrValue, processCustomAttr, processStyleAttr ]
    }, {
        selector: "script",
        elementProcessors: [ processScript ]
    }, {
        selector: "style",
        elementProcessors: [ processStylesheet ]
    }, {
        selector: "input",
        elementProcessors: [ processAutoComplete ]
    }, {
        selector: EVENT_HANDLERS_SELECTOR,
        elementProcessors: [ processEvtHandlers ]
    } ];
    var getElementForSelectorCheck = function($el) {
        if (!isNode && $.browser.msie && parseInt($.browser.version, 10) === 9 && $el[0].tagName.toLowerCase() === "script") {
            var $clone = $(TCC.sandboxes.dom.nativeMethods.cloneNode.call($el[0], false));
            $clone[0].src = $clone[0].innerHTML = "";
            return $clone;
        }
        return $el;
    };
    var isTestCafeElement = function($el) {
        var el = $el[0];
        return typeof el.className === "string" && el.className.indexOf(consts.TEST_CAFE_UI_CLASSNAME_POSTFIX) > -1;
    };
    root.processPage = function($, urlReplacer) {
        for (var i = 0; i < ELEMENT_PROCESSOR_PATTERNS.length; i++) {
            var pattern = ELEMENT_PROCESSOR_PATTERNS[i];
            $(pattern.selector).each(function() {
                if (!this[consts.ELEMENT_PROCESSED_FLAG]) {
                    for (var j = 0; j < pattern.elementProcessors.length; j++) {
                        pattern.elementProcessors[j]($(this), urlReplacer, pattern);
                    }
                }
            });
        }
    };
    root.processElement = function($el, urlReplacer) {
        var $elementForSelectorCheck = getElementForSelectorCheck($el);
        for (var i = 0; i < ELEMENT_PROCESSOR_PATTERNS.length; i++) {
            var pattern = ELEMENT_PROCESSOR_PATTERNS[i];
            if ($elementForSelectorCheck.is(pattern.selector) && !isTestCafeElement($el)) {
                for (var j = 0; j < pattern.elementProcessors.length; j++) {
                    pattern.elementProcessors[j]($el, urlReplacer, pattern);
                }
            }
        }
    };
    root.wrapProps = function(text) {
        return text && typeof text === "string" ? text.replace(wrapRegEx, function() {
            return root.getWrapper(arguments[1]) + arguments[2];
        }) : text;
    };
    root.removeDomSandboxWrapperPrefixClutter = function(text) {
        return text && typeof text === "string" ? text.replace(unwrapRegEx, function() {
            return wrapReplacements[arguments[1]] + arguments[2];
        }) : text;
    };
    root.isJSON = function(text) {
        return /^\s*\{.*\}\s*$/.test(text);
    };
    root.isDataScript = function(text) {
        return root.isJSON(text) || /^\s*\[.*\]\s*$/.test(text);
    };
    root.getWrapper = function(name) {
        return name.slice(0, -1) + consts.DOM_SANDBOX_WRAPPER_SYMBOL;
    };
    root.processScript = function(text, wrappersOnly) {
        var bom = getBOM(text), isDataScript = root.isDataScript(text);
        if (bom) {
            text.replace(bom, "");
        }
        if (!isDataScript && !wrappersOnly && text.indexOf(consts.DOM_SANDBOX_OVERRIDE_DOM_METHOD_NAME) === -1) {
            var overrideDomMeth = "window['" + consts.DOM_SANDBOX_OVERRIDE_DOM_METHOD_NAME + "']";
            text = "\r\ntypeof window !== 'undefined' && " + overrideDomMeth + " && " + overrideDomMeth + "();\r\n" + text;
        }
        text = root.wrapProps(text);
        return bom ? bom + text : text;
    };
    root.processManifest = function(manifest, urlReplacer) {
        var lines = manifest.split("\n"), trim = function(str) {
            return str.replace(/^\s+|\s+$/g, "");
        };
        for (var i = 0; i < lines.length; i++) {
            var line = trim(lines[i]);
            if (line && line !== "CACHE MANIFEST" && line !== "NETWORK:" && line !== "FALLBACK:" && line !== "CACHE:" && line[0] !== "#" && line !== "*") {
                var isFallbackItem = line.indexOf(" ") !== -1;
                if (isFallbackItem) {
                    var urls = line.split(" ");
                    lines[i] = urlReplacer(urls[0]) + " " + urlReplacer(urls[1]);
                } else {
                    lines[i] = urlReplacer(line);
                }
            }
        }
        return lines.join("\n");
    };
    root._removeWrapFromCssRule = function(css) {
        var prop = "src", propWrap = root.getWrapper(prop), cssRuleRegEx = new RegExp("({[^}]*)" + propWrap + "(\\s*:)", "g");
        return css.replace(cssRuleRegEx, "$1" + prop + "$2");
    };
    root.processStylesheet = function(css, urlReplacer) {
        css = root.wrapProps(css);
        css = root._removeWrapFromCssRule(css);
        return css.replace(CSS_URL_PROPERTY_VALUE_PATTERN, function() {
            var prefix = arguments[1] || arguments[10], openQuote = arguments[2] || arguments[5] || arguments[11] || arguments[14] || "", resourceUrl = arguments[3] || arguments[6] || arguments[8] || arguments[12] || arguments[15], closeQuote = arguments[4] || arguments[7] || arguments[13] || arguments[16] || "", postfix = arguments[9] || "";
            var proxyUrl = urlReplacer(resourceUrl);
            proxyUrl = root.removeDomSandboxWrapperPrefixClutter(proxyUrl);
            return prefix + openQuote + proxyUrl + closeQuote + postfix;
        });
    };
    root.processHtml = function(html) {
        var replaceUrl = function(tagNames, urlAttr) {
            var urlAttrWrap = root.getWrapper(urlAttr), tagRegEx = new RegExp(TAG_REG_EX_FORMAT.replace("{0}", tagNames).replace("{1}", urlAttr).replace("{2}", urlAttrWrap), "gi"), tagMatches = html.match(tagRegEx) || [];
            for (var i = 0; i < tagMatches.length; i++) {
                var tagNameRegEx = new RegExp(TAG_NAME_REG_EX_FORMAT.replace("{0}", tagNames), "gi"), tagStr = tagMatches[i], newTagStr = tagStr, urlAttrs = parseUrlAttrs(tagStr, urlAttr), attr = urlAttrs[urlAttrWrap] || urlAttrs[urlAttr], newAttrStr = "", tagName = tagNameRegEx.exec(tagStr)[1], isIFrame = tagName.toLowerCase() === "iframe";
                if (!attr.empty) {
                    var isOriginUrl = attr.value.indexOf(urlUtil.REQUEST_DESCRIPTOR_QUERY_KEY) === -1, proxyUrl = isOriginUrl && attr.value !== "" ? urlUtil.convertToProxyUrl(attr.value, isIFrame) : attr.value, originUrl = isOriginUrl ? attr.value : urlUtil.formatUrl(urlUtil.parseProxyUrl(attr.value).originResourceInfo);
                    proxyUrl = root.removeDomSandboxWrapperPrefixClutter(proxyUrl);
                    originUrl = root.wrapProps(originUrl);
                    newAttrStr = " " + urlAttr + "=" + attr.quote + proxyUrl + attr.quote + " " + urlAttrWrap + "=" + attr.quote + originUrl + attr.quote;
                } else {
                    newAttrStr = " " + urlAttr + " " + urlAttrWrap;
                }
                if (urlAttrs[urlAttr] && urlAttrs[urlAttrWrap]) {
                    newTagStr = newTagStr.replace(urlAttrs[urlAttr].str, "");
                }
                newTagStr = newTagStr.replace(attr.str, newAttrStr);
                html = html.replace(tagStr, newTagStr);
            }
        };
        replaceUrl("img|iframe|script|embed", "src");
        replaceUrl("link|a", "href");
        return html;
    };
    root.isCrossDomainIframe = function(el, value) {
        var result = el.tagName.toLowerCase() === "iframe";
        if (result) {
            var src = value || getAttr($(el), root.getWrapper("src")) || getAttr($(el), "src");
            if (src && urlUtil.isSupportedProtocol(src)) {
                value = root.removeDomSandboxWrapperPrefixClutter(src);
                return !urlUtil.sameOriginCheck(location.toString(), value);
            }
        }
        return false;
    };
})();